-- Modern

-- Use this function to perform your initial setup
function setup()
    print("Running Animation")
    
    --Create a scene
    gameWorld = scene.default2d()
    scene.main = gameWorld
    gameWorld.time.autoUpdate = false
    
    --Change the units of the 2d scene
    gameWorld.camera:get(camera).orthoSize = 24
    gameWorld.pixelsPerUnit = 64 
    
    character = gameWorld:entity("cat")
    animator = character:add(SpriteAnimator, 12, true)
    
    
    
    animator:setSheet(asset.Blue_Knight_Run, vec2(16,17)):addFrom("Right Run", vec2(1,1), vec2(1,8)):play("Right Run")
    --animator:add("Fly",{asset.Cat_Animation, asset.Cat}):play("Fly")
    character.uniformScale = 10
    
    
    
    --tutorial
    --[=[
        SpriteAnimation: two way of loading
    
        1. Json: SpriteAnimation(AnimationType, {JSONfile, JSONFileImage}, framePerSecond)
        2. Raw(just img): SpriteAnimation(AnimationType, img, framePerSecond, numberOfRows, numberOfCols, numOfFrames)
    
        attributes:
    
        frames: imageList                                        - All the individual images of the animation
        fileType: SpriteAnimation.JSON or SpriteAnimation.RAW    - Type of file
    
        SpriteAnimator: 
        
        setSheet: functionsheetImg, size, isVertical)           - set the animation sheet to user
        add: function(animationName, SpriteAnimation(parameters))            - adds animation to animator
        addFrom: function (animationName, firstPosOfAnimation, lastPosOfAnimation)   - shows where to add Animation From
        
        getFrameSize: function -> vec2()                         - gets size of current frame in pixels
        getFrameWorldSize: function -> vec2()                    - gets size of current frame in worldSize
        pause: function                                          - pause the current animation
        resume: function                                         - resume the current animation
        fps: number                                              - Frames per second of animation
        goToFrame: function(frameToGoTo)                         - set the frame the animation should be on
        lockAnimation: function                      - lock animation (basically can not play anothor animation
        releaseAnimation: function                   - remove animation from being locked
        getAnimation: function(nameOfAnimation)                  - gets the SpriteAnimation of the animation with the name
        getCurrentAnimation: function                            - gets the SpriteAnimation of current animation
        play: function(animationName)                            - having one parameter play the animation forever (loop)
        play: function(animationName, numTimesLoop)              - plays loop animation a certain number of time
        setFPS: function(num)                                    - changes the frame rate of the animation
        loop: function(num)                                      - set the number of times you want the animation to loop 
        onComplete: function(onCompleteFunction)                 - runs a function when the animation finish looping
        setSmooth: function(shouldSmooth)                        - set to false if you are doing pixel art else true
    ]=]
end

-- This function gets called once every frame
function draw()
    
    gameWorld:update(time.delta)
    gameWorld:draw()
    
end

