SpriteAnimation = class("SpriteAnimation")

SpriteAnimation.JSON = 1
SpriteAnimation.RAW = 0

function SpriteAnimation:init(sheetImg, rows, cols, num)
    -- you can accept and set parameters here
    
    self.sheetImg = nil
    self.frames = {}
    
    if sheetImg then
        if type(sheetImg) == "userdata" then
            self.fileType = SpriteAnimation.RAW
        else
            self.fileType = SpriteAnimation.JSON
        end
            
        if self.fileType == SpriteAnimation.RAW then
            if num == nil then
                num = rows * cols
            end
            self.sheetImg = image.read(sheetImg)
            self.frameSize = vec2(self.sheetImg.width / cols, self.sheetImg.height / rows);
            local shouldBreak = false
            for j = 0, self.sheetImg.height - 1, self.frameSize.y do
                for i = 0, self.sheetImg.width - 1, self.frameSize.x do
                    table.insert(self.frames, self.sheetImg.slice:rect(i, j, self.frameSize.x, self.frameSize.y))
                    num = num - 1
                    if num == 0 then
                        shouldBreak = true
                        break;
                    end
                end
                if shouldBreak then
                    break
                end
            end
        elseif self.fileType == SpriteAnimation.JSON then
            self.sheetImg = image.read(sheetImg[2])
            jsonText = string.read(sheetImg[1])
            
            local animation = json.decode(jsonText)
            table.sort(animation.frames, function(a,b) 
                if(#a.filename ~= #b.filename ) then
                    return #a.filename < #b.filename 
                end
                
                return a.filename < b.filename end)
            
            for k, frameImg in ipairs(animation.frames) do
                table.insert(self.frames, self.sheetImg.slice:rect(frameImg.frame.x, frameImg.frame.y, frameImg.frame.w, frameImg.frame.h))
            end
        end
    end
end
